{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 19 February 2002.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 24 July 2004

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
unit main;

interface

uses
  Controls, Forms,
  ZLib, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdMessageClient, IdSMTP, ExtCtrls, Classes, ActnList, Dialogs, StdCtrls,
  ComCtrls, Grids, ValEdit;

const
  laCopyright1='      ,';
  laCopyright2=' proxy WinGate,    .';
  laCopyright3='    ,  ';
  laCopyright4='     ';
  laCopyright5='     ';
  laCopyright6='      ';
  laCopyright7='Internet.     , , ,';
  laCopyright8='  shareware  freeware.';
  laCopyright9=' ,   -     ';
  laCopyright10=' :   ';
  laCopyright11='ICQ:119889583   mail:nikitayev@rsu.ru';
  laCopyright12=' -        .';
type
  {$A-}
  IPRecord = packed record
    a,b,c,d:byte;
  end;
  ProtocolName = string[4];
  TLogin = string[16];
  pIDListItem=^IDListItem;
  IDListItem = record
    ID:Integer;
    //IP:IPRecord;
    //Traffic:Integer;
    Protocol:ProtocolName;
    Login:TLogin;
    Site:string;
  end;

  TIDList=class(TList)
  private
    function GetItems(Index: Integer): pIDListItem;
    procedure SetItems(Index: Integer; const Value: pIDListItem);
  public
    destructor Destroy; override;
    function Add(Item: pIDListItem): Integer;overload;
    function Add(const Item: IDListItem): Integer;overload;
    function Add(const ID:Integer;const Protocol:ProtocolName;
                 const Login,Site:string): Integer;overload;
    procedure Clear; override;
    procedure Delete(Index: Integer);
    property Items[Index: Integer]: pIDListItem read GetItems write SetItems; default;
    function Find (const ID:integer):Integer; //Finding
  end;

  pTSiteItem=^TSiteItem;
  TSiteItem = record
   Site:string;
   HTTPTraffic:integer;
   FTPTraffic:integer;
   POP3Traffic:integer;
   SSLTraffic:integer;
   SMTPTraffic:integer;
   SOCKSTraffic:integer;
  end;

  TSitesList=class(TList)
  private
    function GetItems(Index: Integer): pTSiteItem;
    procedure SetItems(Index: Integer; const Value: pTSiteItem);
  public
    destructor Destroy; override;
    function Add(const Site:string;const Protocol:ProtocolName;
                 const Traffic:integer): Integer;
    procedure Clear; override;
    procedure FillTreeNode(const TreeNodes:TTreeNodes;const Parent:TTreeNode);
    procedure Delete(Index: Integer);
    property Items[Index: Integer]: pTSiteItem read GetItems write SetItems; default;
    procedure Sort;
    function Find (const Name:string):Integer; //Finding
  end;

  pTIPItem=^TIPItem;
  TIPItem = record
   IP:IPRecord;
   Traffic:integer;
   Sites:TSitesList;
  end;

  function AsIPrecord(const IP1,IP2,IP3,IP4:byte):IPrecord;

type
  TIPList=class(TList)
  private
    function GetItems(Index: Integer): pTIPItem;
    procedure SetItems(Index: Integer; const Value: pTIPItem);
  public
    destructor Destroy; override;
    function Add(const IP1,IP2,IP3,IP4:byte;const Protocol:ProtocolName;
                 const Site:string;const Traffic:integer): Integer;
    procedure FillTreeNodes (const TreeNodes:TTreeNodes;const Parent:TTreeNode);
    procedure Clear; override;
    procedure Sort;
    procedure Delete(Index: Integer);
    property Items[Index: Integer]: pTIPItem read GetItems write SetItems; default;
    function Find (const IP:IPrecord):Integer; //Finding
  end;

  pTLoginItem=^TLoginItem;
  TLoginItem = record
   Login:String;
   Traffic:integer;
   Sites:TSitesList;
  end;

  TLoginList=class(TList)
  private
    function GetItems(Index: Integer): pTLoginItem;
    procedure SetItems(Index: Integer; const Value: pTLoginItem);
  public
    destructor Destroy; override;
    function Add(const Login:string;const Protocol:ProtocolName;
                 const Site:string;const Traffic:integer): Integer;
    procedure FillTreeNodes (const TreeNodes:TTreeNodes;const Parent:TTreeNode);
    procedure Clear; override;
    procedure Sort;
    procedure Delete(Index: Integer);
    property Items[Index: Integer]: pTLoginItem read GetItems write SetItems; default;
    function Find (const Login:String):Integer; //Finding
  end;

  TForm1 = class(TForm)
    LoadNewButton: TButton;
    OpenDialog: TOpenDialog;
    PageControl1: TPageControl;
    All: TTabSheet;
    MainValueListEditor: TValueListEditor;
    Sites: TTabSheet;
    PageControl2: TPageControl;
    IPUsers: TTabSheet;
    IPUsersTreeView: TTreeView;
    Options: TTabSheet;
    IgnoreString: TLabel;
    IgnoredS: TEdit;
    SitesTreeView: TTreeView;
    SaveDialog: TSaveDialog;
    ActionList: TActionList;
    FindAction: TAction;
    KeyWord: TEdit;
    AboutAction: TAction;
    OpenZIPDialog: TOpenDialog;
    MailGroupBox: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    TemporaryDir: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    GroupBox1: TGroupBox;
    Save: TButton;
    Load: TButton;
    Send: TButton;
    Button1: TButton;
    Edit2: TEdit;
    Label7: TLabel;
    Timer: TTimer;
    Label8: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Edit9: TEdit;
    Button2: TButton;
    Users: TTabSheet;
    UsersTreeView: TTreeView;
    TotalLoadButton: TButton;
    Label11: TLabel;
    Edit10: TEdit;
    Button3: TButton;
    Label12: TLabel;
    SMTPClient: TIdSMTP;
    procedure LoadNewButtonClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure FindActionExecute(Sender: TObject);
    procedure AboutActionExecute(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure SendClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FN:string;
    F:System.TextFile;
    Opened:boolean;
    TR_1,TR_2,TR_3,TR_4:integer;//4  
    Ignored:integer;
    TRPOP3,TRHTTP,TRFTP,TRSSL,TRSOCKS,TRSMTP:integer;
    ReqList:TIDList;
    IPList:TIPList;
    LoginList:TLoginList;
    AllHosts:TIPList;
    MinDate,MaxDate:TDate;
    MinTime,MaxTime:TTime;
    procedure OpenFile(const FileName:string);
    procedure SaveResults (const FileName:string);
    procedure Parse (var s:string);
    procedure CloseFile;
  end;


var
  Form1: TForm1;

implementation

uses Windows,SysUtils, IniFiles,DateRange,Graphics, About, DirSelect,IdMessage,
  Registry;

{$R *.dfm}

function AsIPrecord(const IP1,IP2,IP3,IP4:byte):IPrecord;
begin
  result.a:=IP1;
  result.b:=IP2;
  result.c:=IP3;
  result.d:=IP4;
end;

function IPrecordAsText(const IP:IPrecord):string;
begin
  result:=IntToStr(IP.a)+'.'+IntToStr(IP.b)+'.'+
          IntToStr(IP.c)+'.'+IntToStr(IP.d);
end;

{ TForm1 }

procedure TForm1.CloseFile;
begin
 {$I-}
 if Opened then System.CloseFile(F);
 Opened:=false;
 FN:='';
end;

procedure TForm1.OpenFile(const FileName: string);
begin
  CloseFile;

  if FileName='' then exit;
  AssignFile(F,FileName);
  try
  {$I+}
   Reset(F,FileName);
   FN:=FileName;
   Opened:=true;
  {$I-}
  except
    CloseFile;
  end;
end;

procedure TForm1.LoadNewButtonClick(Sender: TObject);
var i:integer;
    S,dir:string;
    ResMain:TStringList;
    sr: TSearchRec;

begin
  if TButton(Sender).Name='LoadNewButton' then
    if not OpenDialog.Execute then exit;
  TR_1:=0;
  TR_2:=0;
  TR_3:=0;
  TR_4:=0;
  TRPOP3:=0;TRHTTP:=0;TRFTP:=0;TRSSL:=0;TRSOCKS:=0;TRSMTP:=0;
  Ignored:=0;

  ReqList:=TIDList.Create;
  IPList:=TIPList.Create;
  LoginList:=TLoginList.Create;
  AllHosts:=TIPList.Create;

  with TForm4.Create(Self) do
  begin
    if ShowModal=IDOK then
    begin
       MinDate:=MonthCalendar1.Date+Frac(DateTimePicker1.Time);
       MaxDate:=MonthCalendar1.EndDate+Frac(DateTimePicker2.Time);
     end;
    Free;
  end;

  Screen.Cursor:=crHourGlass;

  DateSeparator:='/';
  ShortDateFormat:='m/y/d';
  TimeSeparator:=':';

  if TButton(Sender).Name='LoadNewButton' then
  begin
     for i:=0 to OpenDialog.Files.Count-1 do
     begin
       OpenFile(OpenDialog.Files[i]);
         while not Eof(F) do
            Parse(s);
     end;
  end else
  begin
    dir:=Edit10.Text+'\logs\WWW Proxy server\';

    if FindFirst(dir+'*.log', 0, sr) = 0 then
    begin
      repeat
          OpenFile(dir+sr.Name);
          while not Eof(F) do Parse(s);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

    dir:=Edit10.Text+'\logs\FTP Proxy server\';

    if FindFirst(dir+'*.log', 0, sr) = 0 then
    begin
      repeat
          OpenFile(dir+sr.Name);
          while not Eof(F) do Parse(s);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

    dir:=Edit10.Text+'\logs\SOCKS Proxy server\';

    if FindFirst(dir+'*.log', 0, sr) = 0 then
    begin
      repeat
          OpenFile(dir+sr.Name);
          while not Eof(F) do Parse(s);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

    dir:=Edit10.Text+'\logs\SMTP Proxy\';

    if FindFirst(dir+'*.log', 0, sr) = 0 then
    begin
      repeat
          OpenFile(dir+sr.Name);
          while not Eof(F) do Parse(s);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

    dir:=Edit10.Text+'\logs\POP3 Proxy server\';

    if FindFirst(dir+'*.log', 0, sr) = 0 then
    begin
      repeat
          OpenFile(dir+sr.Name);
          while not Eof(F) do Parse(s);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

  end;

  CloseFile;

  try
  with MainValueListEditor do
  begin
    Strings.Clear;
    ResMain:=TStringList.Create;
    ResMain.Add('TOTAL=');
    ResMain.Add('Client received='+IntToStr(TR_1));
    ResMain.Add('Sending to host ='+IntToStr(TR_2));
    ResMain.Add('Recieved from client ='+IntToStr(TR_3));
    ResMain.Add('All traffic ='+IntToStr(TR_4));
    ResMain.Add('Ignored ='+IntToStr(Ignored));
    ResMain.Add('PROTOCOLS=');
    ResMain.Add('HTTP='+IntToStr(TRHTTP));
    ResMain.Add('FTP='+IntToStr(TRFTP));
    ResMain.Add('SSL='+IntToStr(TRSSL));
    ResMain.Add('POP3='+IntToStr(TRPOP3));
    ResMain.Add('SMTP='+IntToStr(TRSMTP));
    ResMain.Add('SOCKS='+IntToStr(TRSOCKS));
    Strings.AddStrings(ResMain);
    ResMain.Free;
  end;
  except
  end;

  IPList.Sort;
  LoginList.Sort;
  AllHosts.Sort;
  UsersTreeView.Items.Clear;
  IPUsersTreeView.Items.Clear;
  SitesTreeView.Items.Clear;
  if LoginList.Count>1 then
    LoginList.FillTreeNodes(UsersTreeView.Items,nil);
  IPList.FillTreeNodes(IPUsersTreeView.Items,nil);
  AllHosts.FillTreeNodes(SitesTreeView.Items,nil);


  AllHosts.Free;
  ReqList.Free;
  IPList.Free;
  LoginList.Free;

  Screen.Cursor:=crDefault;

end;

procedure TForm1.Parse(var s: string);
var
    res,tmp:string;
    i,Code,Num,ID,IP1,IP2,IP3,IP4,Traffic:integer;
    Protocol:ProtocolName;
    DT:TDateTime;
    Login:string;
    Site:string;
begin
  if Opened then
     begin
       ReadLN(F,s);

       //date + time
       i:=pos(#9,s);
        if i=0 then exit;
        res:=copy(s,1,i-1);
        delete(s,1,i);
        DT:=StrToDateTime(res);
        if (DT<MinDate) or (DT>MaxDate) then exit;
       //IP
       i:=pos('.',s);
        res:=copy(s,1,i-1);
        delete(s,1,i);
        Val(res,IP1,Code);
        if Code>0 then exit;
       i:=pos('.',s);
        res:=copy(s,1,i-1);
        delete(s,1,i);
        Val(res,IP2,Code);
       i:=pos('.',s);
        res:=copy(s,1,i-1);
        delete(s,1,i);
        Val(res,IP3,Code);
       i:=pos(#9,s);
        if i=0 then exit;
        res:=copy(s,1,i-1);
        delete(s,1,i);
        Val(res,IP4,Code);
       //ID
       i:=pos(#9,s);
        if i=0 then exit;
        res:=copy(s,1,i-1);
        delete(s,1,i);
        Val(res,ID,Code);
        if Code>0 then // -    
        begin
        Login:=res;
        i:=pos(#9,s);
         res:=copy(s,1,i-1);
         delete(s,1,i);
         Val(res,ID,Code);
        end;
       //case
       i:=pos(#9,s);
        tmp:=copy(s,1,i-1);
        delete(s,1,i);
        if tmp='Traffic' then
        begin
          Num:=ReqList.Find(ID);
          if Num=-1 then exit;

          i:=pos(#9,s);
           tmp:=copy(s,1,i-1);
           delete(s,1,i);
           inc(TR_1,StrToInt(tmp));
          i:=pos(#9,s);
           tmp:=copy(s,1,i-1);
           delete(s,1,i);
           inc(TR_2,StrToInt(tmp));
          i:=pos(#9,s);
           tmp:=copy(s,1,i-1);
           delete(s,1,i);
           inc(TR_3,StrToInt(tmp));
          i:=pos(#9,s);
           tmp:=copy(s,1,i-1);
           delete(s,1,i);
           Traffic:=StrToInt(tmp);
           inc(TR_4,Traffic);

          if pos(IgnoredS.Text,ReqList[Num].Site)=0 then
          begin

            if ReqList[Num].Protocol='POP3' then
            inc(TRPOP3,Traffic) else
            if ReqList[Num].Protocol='http' then
            inc(TRHTTP,Traffic) else
            if ReqList[Num].Protocol='ftp' then
            inc(TRFTP,Traffic) else
            if ReqList[Num].Protocol='SSL' then
            inc(TRSSL,Traffic) else
            if ReqList[Num].Protocol='SOCKS' then
            inc(TRSOCKS,Traffic) else
            if ReqList[Num].Protocol='SMTP' then
            inc(TRSMTP,Traffic);

            IPList.Add(IP1,IP2,IP3,IP4,ReqList[Num].Protocol,
                       ReqList[Num].Site,Traffic);
            LoginList.Add(Login,ReqList[Num].Protocol,
                       ReqList[Num].Site,Traffic);
            AllHosts.Add(127,0,0,1,ReqList[Num].Protocol,
                       ReqList[Num].Site,Traffic);

          end else
          begin
            inc(Ignored,Traffic);
          end;

          ReqList.Delete(Num);

        end else
        if (tmp='Requested:') or (tmp='Requested') then
        begin
          i:=pos(':',s);
           Protocol:=copy(s,1,i-1);
           delete(s,1,i);


          if (Protocol='http') then
          begin
            delete(s,1,2);        //delete double slash
            if s<>'' then
            begin
              Login:='';
              i:=pos('/',s);      //site
              tmp:=copy(s,1,i-1);
              site:=tmp;
            end;
          end

           else

          if (Protocol='SSL') then
          begin
            delete(s,1,2);        //delete double slash
            if s<>'' then
            begin
              Login:='';
              i:=pos(':',s);      //site
              tmp:=copy(s,1,i-1);
              site:=tmp;
            end;
          end

           else

          if (Protocol='POP3') then
          begin
            if s<>'' then
            begin
              delete(s,1,1);
              i:=pos(' ',s);      //login
               tmp:=copy(s,1,i-1);
               Login:=tmp;
               delete(s,1,i);
              i:=pos(' ',s);      //delete 'at'
               delete(s,1,i);

               site:=s;           //site
            end;
          end

           else

          if (Protocol='ftp') then
            if copy(s,1,2)='//' then
            begin
              Login:='';
              delete(s,1,2);
              i:=pos('/',s);      //site
              tmp:=copy(s,1,i-1);
             site:=tmp;
            end else
            begin
              delete(s,1,1);
              i:=pos(' ',s);      //login
               tmp:=copy(s,1,i-1);
               Login:=tmp;
               delete(s,1,i);
              i:=pos(' ',s);      //delete 'at'
               delete(s,1,i);

               site:=s;           //site
            end;


          ReqList.Add(ID,Protocol,Login,Site);

        end else
        if tmp='Created' then
        begin
          i:=pos(':',s);
           Protocol:=copy(s,1,i-1);
          if (Protocol='SOCKS') or (Protocol='SMTP') then
          begin
            ReqList.Add(ID,Protocol,'','');
          end;
        end;

     end;
end;


{ TIDList }

function TIDList.Add(const ID:Integer;
                 const Protocol:ProtocolName;const Login,Site:string): Integer;
var p:pIDListItem;
begin
 new (p);
 p^.ID:=ID;
 p^.Protocol:=Protocol;
 p^.Login:=Login;
 p^.Site:=Site;
 result:=inherited Add(p);
end;

function TIDList.Add(const Item: IDListItem): Integer;
var p:pIDListItem;
begin
 new (p);
 p^:=Item;
 result:=inherited Add(p);
end;

function TIDList.Add(Item: pIDListItem): Integer;
begin
 result:=inherited Add(Item);
end;

procedure TIDList.Clear;
var i:integer;
begin
  for i:=Count-1 downto 0 do
   Delete(i);
  Pack; 
end;

procedure TIDList.Delete(Index: Integer);
begin
  dispose(inherited Items[index]);
  inherited;
end;

destructor TIDList.Destroy;
begin
  Clear;
  inherited;
end;

function TIDList.Find(const ID: integer): integer;
var i:integer;
begin
  i:=0;
  while i<Count do
  begin
    if Items[i].ID=ID then break;
    inc(i);
  end;
  if i=Count then Result:=-1 else
    Result:=i;
end;

function TIDList.GetItems(Index: Integer): pIDListItem;
begin
  result:=inherited Items[Index];
end;

procedure TIDList.SetItems(Index: Integer; const Value: pIDListItem);
begin
  inherited Items[Index]:=Value;
end;

{ TSitesList }

function TSitesList.Add(const Site: string; const Protocol: ProtocolName;
  const Traffic: integer): Integer;
var p:pTSiteItem;
    i:integer;
begin
 i:=0;

 while (i<Count) and (string(Items[i].Site)<>Site)
       do inc(i);

 if i=Count then
 begin
   new(p);
   p.Site:=Site;
   p.HTTPTraffic:=0;
   p.FTPTraffic:=0;
   p.POP3Traffic:=0;
   p.SSLTraffic:=0;
   p.SMTPTraffic:=0;
   p.SOCKSTraffic:=0;
   inherited Add(p);
 end;

   if Protocol='http' then
     Items[i].HTTPTraffic:=Items[i].HTTPTraffic+Traffic else
   if Protocol='ftp' then
     Items[i].FTPTraffic:=Items[i].FTPTraffic+Traffic else
   if Protocol='POP3' then
     Items[i].POP3Traffic:=Items[i].POP3Traffic+Traffic else
   if Protocol='SSL' then
     Items[i].SSLTraffic:=Items[i].SSLTraffic+Traffic else
   if Protocol='SMTP' then
     Items[i].SMTPTraffic:=Items[i].SMTPTraffic+Traffic else
   if Protocol='SOCKS' then
     Items[i].SOCKSTraffic:=Items[i].SOCKSTraffic+Traffic;

 result:=i;    
end;

procedure TSitesList.Clear;
var i:integer;
begin
  for i:=Count-1 downto 0 do Delete(i); 
  Pack;
end;

procedure TSitesList.Delete(Index: Integer);
begin
  dispose(inherited Items[index]);
  inherited;
end;

destructor TSitesList.Destroy;
begin
  Clear;
  inherited;
end;

procedure TSitesList.FillTreeNode(const TreeNodes: TTreeNodes;const Parent:TTreeNode);
var i:Integer;
    Node:TTreeNode;
begin
 for i:=0 to Count-1 do
 begin
   Node:=TreeNodes.AddChild(Parent,string(Items[i].Site));
     TreeNodes.AddChild(Node,'HTTP:'+IntToStr(Items[i].HTTPTraffic));
     TreeNodes.AddChild(Node,'FTP:'+IntToStr(Items[i].FTPTraffic));
     TreeNodes.AddChild(Node,'POP3:'+IntToStr(Items[i].POP3Traffic));
     TreeNodes.AddChild(Node,'SSL:'+IntToStr(Items[i].SSLTraffic));
     TreeNodes.AddChild(Node,'SMTP:'+IntToStr(Items[i].SMTPTraffic));
     TreeNodes.AddChild(Node,'SOCKS:'+IntToStr(Items[i].SOCKSTraffic));

 end;
end;

function TSitesList.Find(const Name: string): Integer;
begin
 Result:=0;

 while (Result<Count) and (string(Items[Result].Site)<>Name)
   do inc(Result);

 if Result=Count then Result:=-1;

end;

function TSitesList.GetItems(Index: Integer): pTSiteItem;
begin
  result:=inherited Items[Index];
end;

procedure TSitesList.SetItems(Index: Integer; const Value: pTSiteItem);
begin
  inherited Items[Index]:=Value;
end;


function CompareSites (Item1, Item2: Pointer): Integer;
var T1,T2:integer;
begin
  with pTSiteItem(Item1)^ do
  T1:=HTTPTraffic+FTPTraffic+POP3Traffic+SSLTraffic+SMTPTraffic+SOCKSTraffic;

  with pTSiteItem(Item2)^ do
  T2:=HTTPTraffic+FTPTraffic+POP3Traffic+SSLTraffic+SMTPTraffic+SOCKSTraffic;

  result:=T2-T1;
end;

procedure TSitesList.Sort;
begin
  inherited Sort(CompareSites);
end;

{ TIPList }

function TIPList.Add(const IP1, IP2, IP3, IP4: byte;
  const Protocol: ProtocolName; const Site: string;const Traffic:integer): Integer;

var
  p:pTIPItem;
  i:integer;
begin
 i:=0;

 while (i<Count) and (longint(Items[i].IP)<>longint(AsIPrecord(IP1,IP2,IP3,IP4)))
      do inc(i);

 if i=Count then
 begin
   new(p);
   p.IP:=AsIPrecord(IP1,IP2,IP3,IP4);
   inc(p.Traffic,Traffic);
   p.Sites:=TSitesList.Create;
   p.Sites.Add(Site,Protocol,Traffic);
   result:=inherited Add(p);
 end else
 begin
   inc(Items[i].Traffic,Traffic);
   Items[i].Sites.Add(Site,Protocol,Traffic);
   result:=i;
 end;

end;

procedure TIPList.Clear;
var i:integer;
begin
  for i:=Count-1 downto 0 do Delete(i);
  Pack;
end;

procedure TIPList.Delete(Index: Integer);
begin
  dispose(inherited Items[index]);
  inherited;
end;

destructor TIPList.Destroy;
begin
  Clear;
  inherited;
end;

procedure TIPList.FillTreeNodes(const TreeNodes: TTreeNodes;const Parent:TTreeNode);
var I:integer;
    Node:TTreeNode;
begin
 for i:=0 to Count-1 do
  begin
    Node:=TreeNodes.Add(Parent,IPrecordAsText(Items[i].IP));
    TreeNodes.AddChild(Node,'Traffic:'+IntToStr(Items[i].Traffic));
    Items[i].Sites.FillTreeNode(TreeNodes,Node);
  end;
end;

function TIPList.Find(const IP: IPrecord): Integer;
begin
 Result:=0;

 while (Result<Count) and (longint(Items[Result].IP)<>longint(IP))
   do inc(Result);

 if Result=Count then Result:=-1;
end;

function TIPList.GetItems(Index: Integer): pTIPItem;
begin
  result:=inherited Items[Index];
end;

procedure TIPList.SetItems(Index: Integer; const Value: pTIPItem);
begin
  inherited Items[Index]:=Value;
end;

function CompareIP (Item1, Item2: Pointer): Integer;
begin
  result:=pTIPItem(Item2).Traffic-pTIPItem(Item1).Traffic;
end;

procedure TIPList.Sort;
var i:integer;
begin
  inherited Sort(CompareIP);
  for i:=0 to Count-1 do
    Items[i].Sites.Sort;
end;

procedure TForm1.SaveClick(Sender: TObject);
begin
  if SaveDialog.Execute then
   SaveResults(SaveDialog.FileName);
end;

procedure TForm1.SaveResults(const FileName: string);
var FS:TFileStream;
    MS:TMemoryStream;
    ISize:Integer;

begin

//SitesTreeView.SaveToFile(SaveDialog.FileName+'.dbg');
FS:=TFileStream.Create(FileName,fmCreate or fmOpenWrite);
MS:=TMemoryStream.Create;

with ZLib.TCompressionStream.Create(clMax,FS) do
begin

  MainValueListEditor.Strings.SaveToStream(MS);
  ISize:=MS.Size;
  WriteBuffer(ISize,SizeOf(Integer));
  WriteBuffer(MS.Memory^,MS.Size);
  MS.Clear;


  SitesTreeView.SaveToStream(MS);
  ISize:=MS.Size;
  WriteBuffer(ISize,SizeOf(Integer));
  if ISize>0 then
  WriteBuffer(MS.Memory^,MS.Size);
  MS.Clear;

  UsersTreeView.SaveToStream(MS);
  ISize:=MS.Size;
  WriteBuffer(ISize,SizeOf(Integer));
  if ISize>0 then
  WriteBuffer(MS.Memory^,MS.Size);
  MS.Clear;

  IPUsersTreeView.SaveToStream(MS);
  ISize:=MS.Size;
  WriteBuffer(ISize,SizeOf(Integer));
  if ISize>0 then
  WriteBuffer(MS.Memory^,MS.Size);
  MS.Clear;

  Free;
end;

MS.Free;
FS.Free;

end;

procedure TForm1.LoadClick(Sender: TObject);
var FS:TFileStream;
    MS,MSPart:TMemoryStream;
    buf:array of char;
    loadedsize:integer;
    ISize:Integer;
begin

  if OpenZIPDialog.Execute then
  begin
    SetLength(buf,65520);
    MS:=TMemoryStream.Create;
    FS:=TFileStream.Create(OpenZIPDialog.FileName,fmOpenRead);
    with ZLib.TDeCompressionStream.Create(FS) do
    begin
      repeat
       LoadedSize:=Read(buf[0],65520);
       MS.Write(buf[0],LoadedSize);
      until LoadedSize<65520;
      Free;
    end;


    MainValueListEditor.Strings.Clear;
    SitesTreeView.Items.Clear;
    UsersTreeView.Items.Clear;
    IPUsersTreeView.Items.Clear;

    MS.Position:=0;
    MSPart:=TMemoryStream.Create;

    MS.ReadBuffer(ISize,SizeOf(Integer));
    if ISize>0 then
    begin
    MSPart.CopyFrom(MS,ISize);
    MSPart.Position:=0;
    MainValueListEditor.Strings.LoadFromStream(MSPart);
    MSPart.Clear;
    end;

    MS.Read(ISize,SizeOf(Integer));
    if ISize>0 then
    begin
    MSPart.CopyFrom(MS,ISize);
    MSPart.Position:=0;
    SitesTreeView.LoadFromStream(MSPart);
    MSPart.Clear;
    end;

    MS.Read(ISize,SizeOf(Integer));
    if ISize>0 then
    begin
    MSPart.CopyFrom(MS,ISize);
    MSPart.Position:=0;
    UsersTreeView.LoadFromStream(MSPart);
    MSPart.Clear;
    end;

    MS.Read(ISize,SizeOf(Integer));
    if ISize>0 then
    begin
    MSPart.CopyFrom(MS,ISize);
    MSPart.Position:=0;
    IPUsersTreeView.LoadFromStream(MSPart);
    MSPart.Clear;
    end;

    SetLength(buf,0);
    MSPart.Free;
    MS.Free;
    FS.Free;
  end;
end;

procedure TForm1.FindActionExecute(Sender: TObject);
var i,j:Integer;
    AC:TTreeView;
begin
  if ActiveControl is TTreeView then
   begin
     AC:=TTreeView(ActiveControl);
     for i:=0 to AC.Items.Count-1 do
     begin
      for j:=0 to AC.Items[i].Count-1 do
       if pos(KeyWord.Text,AC.Items[i].Item[j].Text)>0 then
        begin
          AC.Items[i].Item[j].Selected:=true;
          AC.Items[i].Item[j].Collapse(true);
        end;
     end;
   end;
end;

procedure TForm1.AboutActionExecute(Sender: TObject);
begin
 Form2.ShowModal;
end;


procedure TForm1.SendClick(Sender: TObject);

  procedure DeleteChar (var s:string;const ch:char);
  var i:Integer;
  begin
    for i:=1 to Length(s) do
      if s[i]=ch then Delete(s,i,1);
  end;

var 
  FileName:string;
  SMTPClient:TIdSMTP;
  MailMessage: TIdMessage;
begin
  DateSeparator:='/';
  FileName:=TemporaryDir.Text+'\logreport '+DateToStr(Now)+'.rep';
  DeleteChar(FileName,'/');
  SaveResults(FileName);


  try
    MailMessage:=TIdMessage.Create(nil);
    with MailMessage do
    begin
      From.Text := Edit5.Text;
      Sender.Text := 'LogAnalyzer';
      Recipients.EMailAddresses := Edit3.Text;
      Subject := Edit4.Text;
      Body.SetText('See attachment.');
      Organization := Edit5.Text;
      Date:=Now;
      ReplyTo.EMailAddresses:='admin@email.net';
      //    
      TIdAttachment.Create(MessageParts,FileName);
    end;
    SMTPClient:=TIdSMTP.Create(nil);
    with SMTPClient do
    begin
      Host:=Edit2.Text;
      UserName:=Edit8.Text;
      Port:=StrToInt(Edit7.Text);
      Send(MailMessage);
    end;
  finally
    DeleteFile(FileName);
    FreeAndNil(SMTPClient);
    FreeAndNil(MailMessage);
  end;  
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form3.DirectoryListBox1.Directory:=TemporaryDir.Text;
  if Form3.ShowModal=mrOK then
    TemporaryDir.Text:=Form3.DirectoryListBox1.Directory;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Form3.DirectoryListBox1.Directory:=Edit9.Text;
  if Form3.ShowModal=mrOK then
    Edit9.Text:=Form3.DirectoryListBox1.Directory;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form3.DirectoryListBox1.Directory:=Edit10.Text;
  if Form3.ShowModal=mrOK then
    Edit10.Text:=Form3.DirectoryListBox1.Directory;

end;

procedure TForm1.FormShow(Sender: TObject);
var INI: TRegistryIniFile;
begin
    with Label12 do
    begin
      Caption:=laCopyRight1;
      Caption:=Caption + laCopyRight2;
      Caption:=Caption + laCopyRight3;
      Caption:=Caption + laCopyRight4;
      Caption:=Caption + laCopyRight5;
      Caption:=Caption + laCopyRight6;
      Caption:=Caption + laCopyRight7;
      Caption:=Caption + laCopyRight8;
      Caption:=Caption + laCopyRight9;
      Caption:=Caption + laCopyRight10;
      Caption:=Caption + laCopyRight11;
      Caption:=Caption + laCopyRight12;
    end;

    try
     INI:=TRegistryIniFile.Create('\Software\RSU\LogAnalyzer',KEY_ALL_ACCESS);

     IgnoredS.Text := INI.ReadString('','Ignored domain','rsu.ru');
     Edit1.Text := INI.ReadString('','Proxy','192.168.1.1');
     Edit2.Text := INI.ReadString('','Host','192.168.1.1');
     Edit6.Text := INI.ReadString('','Proxy port','25');
     TemporaryDir.Text := INI.ReadString('','Temporary directory','c:\WINNT\Temp');
     Edit3.Text := INI.ReadString('','To','');
     Edit4.Text := INI.ReadString('','Subject','Traffic report');
     Edit5.Text := INI.ReadString('','From','LogAnalyzer: Automatic report');
     Edit7.Text := INI.ReadString('','Port','25');
     Edit8.Text := INI.ReadString('','UserID','');
     Edit9.Text := INI.ReadString('','LogDir','');
     Edit10.Text := INI.ReadString('','WinGateDir','c:\Program Files\WinGate');
    // IsPacked.Checked := INI.ReadBool('','Is packed',true);

    except
      Application.MessageBox(
        'Access denied to registry key: \Software\RSU\LogAnalyzer',
        'LogAnalyzer error');
    end;
    FreeAndNil(INI);
    OpenDialog.InitialDir:=Edit9.Text;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var INI: TRegistryIniFile;
begin
    try
     INI:=TRegistryIniFile.Create('\Software\RSU\LogAnalyzer',KEY_ALL_ACCESS);

     INI.WriteString('','Ignored domain',IgnoredS.Text);
     INI.WriteString('','Proxy',Edit1.Text);
     INI.WriteString('','Host',Edit2.Text);
     INI.WriteString('','Proxy port',Edit6.Text);
     INI.WriteString('','Temporary directory',TemporaryDir.Text);
     INI.WriteString('','To',Edit3.Text);
     INI.WriteString('','Subject',Edit4.Text);
     INI.WriteString('','From',Edit5.Text);
     INI.WriteString('','Port',Edit7.Text);
     INI.WriteString('','UserID',Edit8.Text);
     INI.WriteString('','LogDir',Edit9.Text);
     INI.WriteString('','WinGateDir',Edit10.Text);
    // INI.WriteBool('','Is packed',IsPacked.Checked);

    except
      if Application.MessageBox(
        'Access denied to registry key: \Software\RSU\LogAnalyzer',
        'LogAnalyzer error',MB_RETRYCANCEL)=IDRETRY then Action:=caNone else
        Action:=caFree;
    end;
    FreeAndNil(INI);
end;

procedure TForm1.TimerTimer(Sender: TObject);
const b:boolean=true;
begin
 if b then
   begin
    Canvas.Pen.Color:=clGreen;
    Canvas.Brush.Color:=clBlack;
   end else
   begin
    Canvas.Pen.Color:=clBlack;
    Canvas.Brush.Color:=clRed;
   end;
 Canvas.Ellipse(1,8,6,13);
 b:=not b;
end;

procedure TForm1.Edit9Change(Sender: TObject);
begin
  OpenDialog.InitialDir:=Edit9.Text;
end;


{ TLoginList }

function TLoginList.Add(const Login: string; const Protocol: ProtocolName;
  const Site: string; const Traffic: integer): Integer;
var
  p:pTLoginItem;
  i:integer;
begin
 i:=0;

 while (i<Count) and (Items[i].Login<>Login)
      do inc(i);

 if i=Count then
 begin
   new(p);
   p.Login:=Login;
   inc(p.Traffic,Traffic);
   p.Sites:=TSitesList.Create;
   p.Sites.Add(Site,Protocol,Traffic);
   result:=inherited Add(p);
 end else
 begin
   inc(Items[i].Traffic,Traffic);
   Items[i].Sites.Add(Site,Protocol,Traffic);
   result:=i;
 end;
end;

procedure TLoginList.Clear;
var i:integer;
begin
  for i:=Count-1 downto 0 do Delete(i);
  Pack;
end;

procedure TLoginList.Delete(Index: Integer);
begin
  dispose(inherited Items[index]);
  inherited;
end;

destructor TLoginList.Destroy;
begin
  Clear;
  inherited;
end;

procedure TLoginList.FillTreeNodes(const TreeNodes: TTreeNodes;
  const Parent: TTreeNode);
var I:integer;
    Node:TTreeNode;
begin
 for i:=0 to Count-1 do
  begin
    Node:=TreeNodes.Add(Parent,Items[i].Login);
    TreeNodes.AddChild(Node,'Traffic:'+IntToStr(Items[i].Traffic));
    Items[i].Sites.FillTreeNode(TreeNodes,Node);
  end;
end;

function TLoginList.Find(const Login: String): Integer;
begin
 Result:=0;

 while (Result<Count) and (Items[Result].Login<>Login)
   do inc(Result);

 if Result=Count then Result:=-1;
end;

function TLoginList.GetItems(Index: Integer): pTLoginItem;
begin
  Result:=inherited Items[Index];
end;

procedure TLoginList.SetItems(Index: Integer; const Value: pTLoginItem);
begin
  inherited Items[Index]:=Value;
end;

function CompareLogin (Item1, Item2: Pointer): Integer;
begin
  result:=pTLoginItem(Item2).Traffic-pTLoginItem(Item1).Traffic;
end;

procedure TLoginList.Sort;
var i:integer;
begin
  inherited Sort(CompareLogin);
  for i:=0 to Count-1 do
    Items[i].Sites.Sort;
end;



end.
